/*
 * audio_buffer.c
 *
 *  Created on: 19.12.2017
 *      Author: TheMason
 */


#include "stm32f4xx_hal.h"

#include <stdio.h>
#include <string.h>
#include <math.h>

#include "stm32f4xx.h"



#include "audio_buffer.h"

extern void FillBuffer (uint32_t *buffer, uint16_t len);

uint32_t  dma_out_buffer  [BUFFER_SIZE];
uint32_t  dma_inp_buffer  [BUFFER_SIZE];


uint32_t *work_out        = NULL;
uint32_t *work_inp        = NULL;
uint32_t  smp_snt         = 0;





void StartAudioBuffers (I2S_HandleTypeDef *hi2s)
{
  memset (dma_out_buffer,   0, sizeof (dma_out_buffer ));
  memset (dma_inp_buffer,   0, sizeof (dma_inp_buffer ));

  //HAL_I2S_Transmit_DMA (hi2s, (uint16_t *) dma_out_buffer, BUFFER_SIZE << 1);
  //HAL_I2S_Receive_DMA  (hi2s, (uint16_t *) dma_inp_buffer, BUFFER_SIZE << 1);

  HAL_I2SEx_TransmitReceive_DMA(hi2s, (uint16_t *) dma_out_buffer,  (uint16_t *) dma_inp_buffer, BUFFER_SIZE << 1);

  smp_snt = 0;
}

void SwapAudioOutBuffer (uint8_t half)
{
  if (half == 0)  { work_out = &(dma_out_buffer [0                ]); }
  else            { work_out = &(dma_out_buffer [BUFFER_SIZE  >> 1]); }

  FillBuffer      (work_out, BUFFER_SIZE >> 1);

}

void SwapAudioInpBuffer (uint8_t half)
{
  if (half == 0)  { work_inp = &(dma_inp_buffer [0                ]); }
  else            { work_inp = &(dma_inp_buffer [BUFFER_SIZE  >> 1]); }

  //FillBuffer      (work_out, BUFFER_SIZE >> 1);
}



int tog = 0;

void HAL_I2SEx_TxRxCpltCallback(I2S_HandleTypeDef *hi2s)
{
  //SwapAudioOutBuffer (0);
  //SwapAudioOutBuffer (tog);
  SwapAudioOutBuffer (1);
  smp_snt += BUFFER_SIZE;
  tog = tog ? 0 : 1;

}

void HAL_I2SEx_TxRxHalfCpltCallback(I2S_HandleTypeDef *hi2s)
{
  SwapAudioOutBuffer (0);
}




void HAL_I2S_TxCpltCallback(I2S_HandleTypeDef *hi2s)
{
  SwapAudioOutBuffer (1);
  smp_snt += BUFFER_SIZE;
}

void HAL_I2S_TxHalfCpltCallback(I2S_HandleTypeDef *hi2s)
{
  SwapAudioOutBuffer (0);
}


