/*
 * usb_uart_fifo.h
 *
 *  Created on: 11.05.2017
 *      Author: TheMason
 */

#ifndef USB_UART_FIFO_H_
#define USB_UART_FIFO_H_

  #define UART_FIFO_SIZE 256

  typedef struct
  {
    uint8_t data [UART_FIFO_SIZE];
    uint16_t wp;
    uint16_t rp;
  } UART_FIFO;


  #define SHELL_PUTCH   user_tx_put
  #define SHELL_PUTSTR  user_tx_printf
  #define SHELL_GETCH   user_rx_get


  void    UART_FIFO_init  (UART_FIFO *fifo);
  uint8_t UART_FIFO_put   (UART_FIFO *fifo, uint8_t x);
  uint8_t UART_FIFO_get   (UART_FIFO *fifo, uint8_t *x);
  uint8_t UART_FIFO_empty (UART_FIFO *fifo);
  uint8_t UART_FIFO_bytes (UART_FIFO *fifo);


  void    rpi_rx_tx_init  (void);
  uint8_t rpi_rx_put      (uint8_t x);
  uint8_t rpi_rx_get      (uint8_t *x);
  uint8_t rpi_tx_put      (uint8_t x);
  uint8_t rpi_tx_get      (uint8_t *x);
  uint8_t rpi_tx_bytes    (void);
  uint8_t rpi_rx_bytes    (void);

  void    rpi_tx_printf   (char *fmt, ...);


  void    bta_rx_tx_init  (void);
  uint8_t bta_rx_put      (uint8_t x);
  uint8_t bta_rx_get      (uint8_t *x);
  uint8_t bta_tx_put      (uint8_t x);
  uint8_t bta_tx_get      (uint8_t *x);
  uint8_t bta_tx_bytes    (void);
  uint8_t bta_rx_bytes    (void);

  void    bta_tx_printf   (char *fmt, ...);


  void    aux_rx_tx_init  (void);
  uint8_t aux_rx_put      (uint8_t x);
  uint8_t aux_rx_get      (uint8_t *x);
  uint8_t aux_tx_put      (uint8_t x);
  uint8_t aux_tx_get      (uint8_t *x);
  uint8_t aux_tx_bytes    (void);
  uint8_t aux_rx_bytes    (void);

  void    aux_tx_printf   (char *fmt, ...);


  void    user_rx_tx_init (void);
  uint8_t user_rx_put     (uint8_t x);
  uint8_t user_rx_get     (uint8_t *x);
  uint8_t user_tx_put     (uint8_t x);
  uint8_t user_tx_get     (uint8_t *x);
  uint8_t user_tx_bytes   (void);
  uint8_t user_rx_bytes   (void);

  void    user_tx_printf  (char *fmt, ...);

  void InitUARTS            (void);
  void HandleShellComInput  (void);
  void StartUARTReceive     (void);
  void Handle_UARTs         (void);

#endif /* USB_UART_FIFO_H_ */
